Bug 849368 - (CVE-2012-3505) CVE-2012-3505 tinyproxy: multiple headers hashmap DoS
CVE-2012-3505 tinyproxy: multiple headers hashmap DoS
Status: NEW
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
low Severity low
: ---
: ---
Assigned To: Red Hat Product Security
impact=low,public=20120814,reported=2...
: Security
Depends On: 849369 849370
Blocks:
  Show dependency treegraph
 
Reported: 2012-08-18 17:54 EDT by Kurt Seifried
Modified: 2016-01-01 19:09 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
CVE-2012-3505-tinyproxy-limit-headers.patch (1.31 KB, patch)
2012-08-18 17:56 EDT, Kurt Seifried
no flags Details | Diff
CVE-2012-3505-tinyproxy-randomized-hashmaps.patch (3.00 KB, patch)
2012-08-18 17:57 EDT, Kurt Seifried
no flags Details | Diff

  None (edit)
Description Kurt Seifried 2012-08-18 17:54:05 EDT
gpernot reports:

Bug 110 - algorithmic complexity denial of service 

randomized hashmaps to prevent DOS attacks

hashmap are not randomized, so that it is possible to forge fake headers that 
will always go into the same bucket. 
try 'curl http://78.230.4.96/hashes.asis' via tinyproxy and without it to 
convince you (~8 MB of headers). I'll remove this url as soon as bug is 
accepted...

attached patch should solve this. it's certainly perfectible, though 
(autoconf for time() and rand() are missing...).

even with this patch, it takes ages. maybe headers should be sanitized before 
hiting the buckets...

Created attachment 60 [details]
limit number of headers to prevent DoS attacks

External references:
https://banu.com/bugzilla/show_bug.cgi?id=110#c2
https://bugs.launchpad.net/ubuntu/+source/tinyproxy/+bug/1036985
Comment 1 Kurt Seifried 2012-08-18 17:55:06 EDT
Created tinyproxy tracking bugs for this issue

Affects: fedora-all [bug 849369]
Comment 2 Kurt Seifried 2012-08-18 17:56:32 EDT
Created tinyproxy tracking bugs for this issue

Affects: epel-all [bug 849370]
Comment 3 Kurt Seifried 2012-08-18 17:56:51 EDT
Created attachment 605402 [details]
CVE-2012-3505-tinyproxy-limit-headers.patch
Comment 4 Kurt Seifried 2012-08-18 17:57:11 EDT
Created attachment 605403 [details]
CVE-2012-3505-tinyproxy-randomized-hashmaps.patch
Comment 5 Michael Adam 2014-12-12 20:10:29 EST
Believe it or not:
Fixes pushed to upstream and will be released soon with Tinyproxy 1.8.4.
Comment 6 Michael Adam 2016-01-01 19:09:15 EST
Upstream release including fix available at

https://github.com/tinyproxy/tinyproxy/releases/tag/1.8.4

(Note: upstream hosting is currently changing.)

Note You need to log in before you can comment on or make changes to this bug.